searchNodes=[{"doc":"Simple :cowboy (v2) webserver with support for websockets.","ref":"Buckaroo.html","title":"Buckaroo","type":"module"},{"doc":"Setup a simple webserver handling HTTP requests including websockets.","ref":"Buckaroo.html#child_spec/1","title":"Buckaroo.child_spec/1","type":"function"},{"doc":"","ref":"Buckaroo.html#info/3","title":"Buckaroo.info/3","type":"function"},{"doc":"A simple SSE implementation.","ref":"Buckaroo.EventSource.html","title":"Buckaroo.EventSource","type":"behaviour"},{"doc":"Incoming process messages.","ref":"Buckaroo.EventSource.html#c:info/2","title":"Buckaroo.EventSource.info/2","type":"callback"},{"doc":"Initialize the SSE. Passes the connection and the given state.","ref":"Buckaroo.EventSource.html#c:init/2","title":"Buckaroo.EventSource.init/2","type":"callback"},{"doc":"SSE termination.","ref":"Buckaroo.EventSource.html#c:terminate/3","title":"Buckaroo.EventSource.terminate/3","type":"callback"},{"doc":"SSE event.","ref":"Buckaroo.EventSource.html#t:event/0","title":"Buckaroo.EventSource.event/0","type":"type"},{"doc":"SSE callback result.","ref":"Buckaroo.EventSource.html#t:result/1","title":"Buckaroo.EventSource.result/1","type":"type"},{"doc":"An extension to Plug.Router now also supporting websocket.","ref":"Buckaroo.Router.html","title":"Buckaroo.Router","type":"module"},{"doc":"Dispatches to the event source. Server-Sent Events (SSE) is a server push technology enabling a client to receive automatic updates from a server via HTTP connection. See Plug.Router.match/3 for more examples. Example sse &quot;/eventsource&quot;, source: ExampleEventSource","ref":"Buckaroo.Router.html#sse/2","title":"Buckaroo.Router.sse/2","type":"macro"},{"doc":"Dispatches to the websocket. See Plug.Router.match/3 for more examples. Example websocket &quot;/ws&quot;, connect: ExampleSocket","ref":"Buckaroo.Router.html#websocket/2","title":"Buckaroo.Router.websocket/2","type":"macro"},{"doc":"A simple websocket implementation.","ref":"Buckaroo.Socket.html","title":"Buckaroo.Socket","type":"behaviour"},{"doc":"Incoming frames.","ref":"Buckaroo.Socket.html#c:handle/2","title":"Buckaroo.Socket.handle/2","type":"callback"},{"doc":"Incoming process messages.","ref":"Buckaroo.Socket.html#c:info/2","title":"Buckaroo.Socket.info/2","type":"callback"},{"doc":"Initialize the websocket. Passes the connection and the given state.","ref":"Buckaroo.Socket.html#c:init/2","title":"Buckaroo.Socket.init/2","type":"callback"},{"doc":"Websocket termination.","ref":"Buckaroo.Socket.html#c:terminate/3","title":"Buckaroo.Socket.terminate/3","type":"callback"},{"doc":"Websocket frames. Note that there is no need to send pong frames back as Cowboy does it automatically for you.","ref":"Buckaroo.Socket.html#t:frame/0","title":"Buckaroo.Socket.frame/0","type":"type"},{"doc":"Websocket callback result.","ref":"Buckaroo.Socket.html#t:result/1","title":"Buckaroo.Socket.result/1","type":"type"},{"doc":"","ref":"EchoSocket.html","title":"EchoSocket","type":"module"},{"doc":"","ref":"MyApp.html","title":"MyApp","type":"module"},{"doc":"Callback implementation for Application.start/2.","ref":"MyApp.html#start/2","title":"MyApp.start/2","type":"function"},{"doc":"","ref":"MyRouter.html","title":"MyRouter","type":"module"},{"doc":"Callback implementation for Plug.call/2.","ref":"MyRouter.html#call/2","title":"MyRouter.call/2","type":"function"},{"doc":"Callback implementation for Plug.init/1.","ref":"MyRouter.html#init/1","title":"MyRouter.init/1","type":"function"},{"doc":"","ref":"TimeEventSource.html","title":"TimeEventSource","type":"module"},{"doc":"Buckaroo Simple :cowboy (v2) webserver with support for SSE and WebSockets.","ref":"readme.html","title":"Buckaroo","type":"extras"},{"doc":"defmodule EchoSocket do use Buckaroo.Socket @impl Buckaroo.Socket def handle(frame, state), do: {:reply, frame, state} end defmodule TimeEventSource do use Buckaroo.EventSource @impl Buckaroo.EventSource def init(_conn, _opts), do: {:ok, :timer.send_interval(1_000, :time)} @impl Buckaroo.EventSource def info(:time, state), do: {:reply, %{event: &quot;time&quot;, data: :os.system_time()}, state} def info(_message, state), do: {:ok, state} end defmodule MyRouter do use Buckaroo.Router plug :match plug :dispatch websocket &quot;/echo&quot;, connect: EchoSocket sse &quot;/sse/time&quot;, source: TimeEventSource get &quot;/&quot; do Plug.Conn.send_resp(conn, 200, &quot;Welcome&quot;) end end defmodule MyApp do use Application def start(_type, _args) do children = [Buckaroo.child_spec(plug: MyRouter)] Supervisor.start_link(children, strategy: :one_for_one) end end with SSE it is now possible to subscribe to these time events in the browser with the following JavaScript: const es = new EventSource(&#39;/sse/time&#39;); es.addEventListener(&#39;time&#39;, event =&gt; { console.log(&#39;system time&#39;, event.data); });","ref":"readme.html#quick-setup","title":"Buckaroo - Quick Setup","type":"extras"},{"doc":"If connections are being disconnected, it might be necessary to set the :idle_timeout to avoid timeouts. This will definitely be relevant when using SSE EventSources. The :idle_timeout can be set to :infinity to avoid timeouts. Example: Buckaroo.child_spec(plug: MyRouter, protocol_options: [idle_timeout: :infinity])","ref":"readme.html#note","title":"Buckaroo - Note","type":"extras"},{"doc":"The package can be installed by adding buckaroo to your list of dependencies in mix.exs: def deps do [ {:buckaroo, &quot;~&gt; 0.2.0&quot;} ] end The docs can be found at https://hexdocs.pm/buckaroo.","ref":"readme.html#installation","title":"Buckaroo - Installation","type":"extras"},{"doc":"MIT License Copyright (c) 2018 Ian Luites Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the &quot;Software&quot;), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions: The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software. THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.","ref":"license.html","title":"LICENSE","type":"extras"}]